//+------------------------------------------------------------------+
//|                                             CTrade_Sample_EA.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include<Trade\Trade.mqh>
#property description "       "
#property description "  CTrade.      ."

//---     
CTrade  trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---  MagicNumber    
   int MagicNumber=123456;
   trade.SetExpertMagicNumber(MagicNumber);
//---        /
   int deviation=10;
   trade.SetDeviationInPoints(deviation);
//---   
   trade.SetTypeFilling(ORDER_FILLING_RETURN);
//---  :      ,     
   trade.LogLevel(1);
//---     : true - OrderSendAsync(), false - OrderSend()
   trade.SetAsyncMode(true);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- 

  }
//---    
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void BuySample1()
  {
//--- 1.     
   if(!trade.Buy(0.1))
     {
      //---   
      Print(" Buy()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" Buy()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void BuySample2()
  {
//--- 2.     
   if(!trade.Buy(0.1,"GBPUSD"))
     {
      //---   
      Print(" Buy()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" Buy()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void BuySample3()
  {
//--- 3.         SL  TP
   double volume=0.1;         //    
   string symbol="GBPUSD";    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double bid=SymbolInfoDouble(symbol,SYMBOL_BID);             //     LONG
   double SL=bid-1000*point;                                   //   SL
   SL=NormalizeDouble(SL,digits);                              //  Stop Loss
   double TP=bid+1000*point;                                   //   TP
   TP=NormalizeDouble(TP,digits);                              //  Take Profit
//---      LONG 
   double open_price=SymbolInfoDouble(symbol,SYMBOL_ASK);
   string comment=StringFormat("Buy %s %G lots at %s, SL=%s TP=%s",
                               symbol,volume,
                               DoubleToString(open_price,digits),
                               DoubleToString(SL,digits),
                               DoubleToString(TP,digits));
   if(!trade.Buy(volume,symbol,open_price,SL,TP,comment))
     {
      //---   
      Print(" Buy()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" Buy()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//---       
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void BuyLimit_Sample1()
  {
//--- 1.     Buy LImit
   string symbol="GBPUSD";    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
   double price=1000*point;                                    //   
   price=NormalizeDouble(price,digits);                        //   
//---  ,      Buy Limit
   if(!trade.BuyLimit(0.1,price))
     {
      //---   
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
void BuyLimit_Sample2()
  {
//--- 2.     BuyLimit   
   double volume=0.1;
   string symbol="GBPUSD";    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
   double price=1000*point;                                    //   
   price=NormalizeDouble(price,digits);                        //   
   int SL_pips=300;                                            // Stop Loss  
   int TP_pips=500;                                            // Take Profit  
   double SL=price-SL_pips*point;                              //   SL
   SL=NormalizeDouble(SL,digits);                              //  Stop Loss
   double TP=price+TP_pips*point;                              //   TP
   TP=NormalizeDouble(TP,digits);                              //  Take Profit
   datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);
   string comment=StringFormat("Buy Limit %s %G lots at %s, SL=%s TP=%s",
                               symbol,volume,
                               DoubleToString(price,digits),
                               DoubleToString(SL,digits),
                               DoubleToString(TP,digits));
//---  ,      Buy Limit
   if(!trade.BuyLimit(volume,price,symbol,SL,TP,ORDER_TIME_GTC,expiration,comment))
     {
      //---   
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---   
  }
//---         
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void BuyStop_Sample1()
  {
//--- 1.     Buy Stop
   string symbol="USDJPY";    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
   double price=1000*point;                                    //   
   price=NormalizeDouble(price,digits);                        //   
//---  ,      Buy Stop 
   if(!trade.BuyStop(0.1,price))
     {
      //---   
      Print(" BuyStop()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" BuyStop()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---  
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void BuyStop_Sample2()
  {
//--- 2.     Buy Stop   
   double volume=0.1;
   string symbol="USDJPY";    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
   double price=1000*point;                                    //   
   price=NormalizeDouble(price,digits);                        //   
   int SL_pips=300;                                            // Stop Loss  
   int TP_pips=500;                                            // Take Profit  
   double SL=price-SL_pips*point;                              //   SL
   SL=NormalizeDouble(SL,digits);                              //  Stop Loss
   double TP=price+TP_pips*point;                              //   TP
   TP=NormalizeDouble(TP,digits);                              //  Take Profit
   datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);
   string comment=StringFormat("Buy Stop %s %G lots at %s, SL=%s TP=%s",
                               symbol,volume,
                               DoubleToString(price,digits),
                               DoubleToString(SL,digits),
                               DoubleToString(TP,digits));
//---  ,      Buy Stop 
   if(!trade.BuyStop(volume,price,symbol,SL,TP,ORDER_TIME_GTC,expiration,comment))
     {
      //---   
      Print(" BuyStop()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" BuyStop()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---     
  }
//---     
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void Open()
  {
//---    
   int    digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
//---  
   double point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
//---   
   double price=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
//---     SL  TP
   double SL=NormalizeDouble(price-1000*point,digits);
   double TP=NormalizeDouble(price+1000*point,digits);
//---  
   string comment="Buy "+_Symbol+" 0.1 at "+DoubleToString(price,digits);
//---  ,      
   if(!trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,0.1,price,SL,TP,comment))
     {
      //---   
      Print(" PositionOpen()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" PositionOpen()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void Close()
  {
//---     
   if(!trade.PositionClose(_Symbol))
     {
      //---   
      Print(" PositionClose()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" PositionClose()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---     
  }
//+------------------------------------------------------------------+
//|     Long   StopLoss  TakeProfit     |
//+------------------------------------------------------------------+
void ModifyPosition()
  {
//---    
   int    digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
//---  
   double point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
//---    Bid
   double price=SymbolInfoDouble(_Symbol,SYMBOL_BID);
//---     SL  TP
   double SL=NormalizeDouble(price-1000*point,digits);
   double TP=NormalizeDouble(price+1000*point,digits);
//---  ,      
   if(!trade.PositionModify(_Symbol,SL,TP))
     {
      //---   
      Print(" PositionModify()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" PositionModify()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---     
  }
//---     
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteOrder()
  {
//---      ,   
   ulong ticket=1234556;
//---  ,      
   if(!trade.OrderDelete(ticket))
     {
      //---   
      Print(" OrderDelete()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" OrderDelete()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---     
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ModifyOrder()
  {
//---      ,   
   ulong ticket=1234556;
//---     ,   
   string symbol="EURUSD";
//---    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
//---  
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
//---   
   double price=SymbolInfoDouble(symbol,SYMBOL_ASK);
//---     SL  TP
//---           
   double SL=NormalizeDouble(price-1000*point,digits);
   double TP=NormalizeDouble(price+1000*point,digits);
   //---     
   datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);   
//---  ,     
   if(!trade.OrderModify(ticket,price,SL,TP,ORDER_TIME_GTC,expiration))
     {
      //---   
      Print(" OrderModify()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" OrderModify()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }

//+------------------------------------------------------------------+
